
Auto Multiple Choice - Bug # 212: Impressions sous OS X

Status: Closed Priority: Low
Author: Joël Brogniart Category:
Created: 09/24/2013 Assignee:
Updated: 01/06/2016 Due date:
Description: Le module CPAN Net::CUPS n'a pas suivi les dernières évolutions de CUPS et son auteur n'a plus le temps 

de le mettre à jour. Du coup, ce module n'est plus fonctionnel sur les versions récentes d'OS X et il n'est donc 
pas possible d'imprimer directement à partir d'AMC. Ce n'est pas une catastrophe car il est toujours possible 
d'imprimer les documents en dehors d'AMC.

Je n'y connais pas grand chose, mais est-ce que le module CPAN Net::LPR 
(http://search.cpan.org/~dmlloyd/Net-LPR/) pourrait être utilisé à la place de Net::CUPS sous OS X ?

History
09/30/2013 02:57 pm - Joël Brogniart
Je viens de jeter un œil sur les options d'impression d'AMC (RTFM !) et j'ai aussi jeté un œil sur CUPS sous OS X. CUPS sous OS X fournit lp et lpr. 
Du coup, j'ai testé l'impression "par une commande" avec @lp %f@ et @lpr %f@ et les impressions fonctionnent directement depuis AMC. Je pense, 
que pour l'instant, le plus simple, du point de vue utilisateur, serait, pour la version MacPorts et si c'est possible, de ne plus offrir l'option "CUPS" 
comme méthode d'impression ou de la rendre inactive et de mettre "par une commande" (avec "lpr %f") par défaut.

09/30/2013 08:53 pm - Alexis Bienvenüe
C'est sans doute le plus simple, en effet. La difficulté est de transmettre les bonnes options à @lpr@ pour lui demander une impression recto-verso, 
avec agrafage. Je n'ai pas trouvé le moyen de consulter et fixer ce genre d'options avec le paquet Net::LPR non plus.

11/07/2014 01:54 pm - Alexis Bienvenüe
- Target version set to 1.3.0

11/10/2014 10:59 am - Alexis Bienvenüe
- % Done changed from 0 to 100

- Status changed from New to Resolved

Applied in changeset commit:57c05aebbb3a.

04/28/2015 12:17 pm - Alexis Bienvenüe
À partir de la révision commit:f91313c81536, vous devriez pouvoir choisir la méthode d'impression _CUPS (via lp)_, qui utilise les commandes comme 
@lp@ ou @lpstat@ pour l'impression par CUPS, au lieu du paquet perl Net::CUPS. Pouvez-vous me dire si cela fonctionne sous MacOSX ?
Si vous souhaitez contrôler des options d'impression particulières à partir d'AMC (l'agrafage en particulier), ajoutez-les à 
_Edition/Préférences/Général/Impression/Useful printing options_ (ce sera traduit en français).

04/28/2015 12:29 pm - Joël Brogniart
OK, je vais tester la nouvelle version.

04/28/2015 02:29 pm - Joël Brogniart
Bon il semble qu'il y a eu un changement qui pose problème depuis la révision commit:7447b39d84e5 (1721) que j'ai construite et utilisée toute la 
matinée. La construction à partir de la révision commit:f91313c81536 se passe bien, mais au lancement d'AMC, j'ai droit à une erreur @Unknown 
action gui at /opt/local/bin/auto-multiple-choice line 79@.
04/29/2015 08:56 am - Joël Brogniart
Sous OS X 10.10.3, je n'arrive pas à lancer AMC à la révision commit:f91313c81536. Au lancement, j'ai les erreurs suivantes.

<pre>
Can't locate AMC/Print/cups.pm in @INC (@INC contains: /opt/local/lib/perl5/site_perl/5.16.3/darwin-thread-multi-2level 
/opt/local/lib/perl5/site_perl/5.16.3 /opt/local/lib/perl5/vendor_perl/5.16.3/darwin-thread-multi-2level /opt/local/lib/perl5/vendor_perl/5.16.3 
/opt/local/lib/perl5/5.16.3/darwin-thread-multi-2level /opt/local/lib/perl5/5.16.3 /opt/local/lib/perl5/site_perl /opt/local/lib/perl5/vendor_perl .) at 
/opt/local/lib/perl5/vendor_perl/5.16.3/Module/Load.pm line 77.
Can't locate AMC/Print/cups in @INC (@INC contains: /opt/local/lib/perl5/site_perl/5.16.3/darwin-thread-multi-2level /opt/local/lib/perl5/site_perl/5.16.3 
/opt/local/lib/perl5/vendor_perl/5.16.3/darwin-thread-multi-2level /opt/local/lib/perl5/vendor_perl/5.16.3 
/opt/local/lib/perl5/5.16.3/darwin-thread-multi-2level /opt/local/lib/perl5/5.16.3 /opt/local/lib/perl5/site_perl /opt/local/lib/perl5/vendor_perl .) at 
/opt/local/lib/perl5/vendor_perl/5.16.3/Module/Load.pm line 77.
</pre>

04/29/2015 09:39 am - Joël Brogniart
Je pense qu'il manque l'installation de ces fichiers dans le makefile. Quelque chose du genre :

<pre>
--- Makefile	2015-04-28 12:16:05.000000000 +0200
+++ Makefile+print	2015-04-29 09:42:01.000000000 +0200
@@ -232,6 +232,7 @@
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Filter/register
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/DataModule
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Gui
+	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Print
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/*.pm $(DESTDIR)/$(PERLDIR)/AMC
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Export/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Export
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Export/register/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Export/register
@@ -240,6 +241,7 @@
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/DataModule/*.pm $(DESTDIR)/$(PERLDIR)/AMC/DataModule
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Gui/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Gui
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Gui/*.glade $(DESTDIR)/$(PERLDIR)/AMC/Gui
+	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Print/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Print

</pre>

04/29/2015 10:47 am - Alexis Bienvenüe
En effet j'ai rajouté ça dans la révision commit:85268d47d620.

04/29/2015 01:28 pm - Joël Brogniart
Bon tout marche comme il faut. J'ai utilisé l'option @CUPS (via lp)@ et ça marche bien. Les options recto/verso et agrafage standards ne fonctionnent 
pas avec mon imprimante. C'est un copieur numérique N & B Toshiba e-STUDIO357.

Pour le recto-verso j'ai ajouté @Duplex@ dans les "Useful printing options" ce qui me permet de choisir entre @None@ (simple face), 
@DuplexNoTumble@ (recto-verso bord long), @DuplexTumble@ (recto-verso bord court).

Pour l'agrafage, j'ai ajouté @Stapling@ dans les "Useful printing options" ce qui me permet de choisir entre @Off@ (pas d'agrafage), @UL@ (Upper 
Left), @ML@ (Middle Left), @LL@ (Lower Left), @UR@ (Upper Right), @MR@ (Middle Right), @LR@ (Lower Right), @MT@ (Middle Top), @MB@ 
(Middle Bottom) et @SS@ (je n'ai pas trouvé à quoi ça correspond). Ah si, j'ai trouvé dans l'interface standard OS X. @SS@ c'est agrafage à cheval et 
je suppose que ça marche s'il y a une plieuse avec.

La nouvelle option est plus pratique parce que peut choisir plus facilement pour chaque impression.
Merci beaucoup.

Aaaaah je viens juste de voir qu'on peut même choisir l'imprimante. C'est vraiment super.

01/06/2016 09:24 am - Alexis Bienvenüe
- Status changed from Resolved to Closed
